if(select(2, UnitClass('player')) ~= 'DEATHKNIGHT') then 
	return
end

local frostFeverLocal = "Frost Fever";
local bloodPlagueLocal = "Blood Plague";

if GetLocale() == "deDE" then
	frostFeverLocal = "Frostfieber";
	bloodPlagueLocal = "Blutseuche";
elseif GetLocale() == "frFR" then
	frostFeverLocal = "Fivre de givre";
	bloodPlagueLocal = "Peste de sang";
end

local frame_locked = 0;

local isDragging = 0;
local xDragStart = 0;
local yDragStart = 0;

local scaleFocus = -1;
local yStart = 0;
local prevDistance = 0;
local currentWidth = 0;
local wasReset = 0;

local currentTime = GetTime();
local newTime = GetTime();
local deltaTime = 0;
local frameHideAlpha = 1;

-- Draggable Frame -------------------------------------
local dragFrame = CreateFrame("Frame", "Backgroundframe", UIParent)
dragFrame:SetPoint("CENTER", 0, 0);
dragFrame:SetWidth(130);
dragFrame:SetHeight(90);
local dragTex = dragFrame:CreateTexture("ARTWORK");
dragTex:SetAllPoints();
dragTex:SetTexture(0.5, 1, 0.5);
dragTex:SetAlpha(0);


-- Addon Render frame ------------------------------
local frame = CreateFrame("Frame", nil, UIParent);
frame:SetPoint("CENTER", dragFrame, "CENTER", 0, 0);
frame:SetWidth(1);
frame:SetHeight(1);


-- Addon scale frames ------------------------------
local diseaseAnchor = CreateFrame("Frame", nil, frame)
diseaseAnchor:SetPoint("CENTER", frame, "CENTER", 0, 38); 
diseaseAnchor:SetWidth(1);
diseaseAnchor:SetHeight(1);

local targetAnchor = CreateFrame("Frame", nil, frame)
targetAnchor:SetPoint("CENTER", frame, "CENTER", 0, 20); 
targetAnchor:SetWidth(1);
targetAnchor:SetHeight(1);

local runeAnchor = CreateFrame("Frame", nil, frame)
runeAnchor:SetPoint("CENTER", frame, "CENTER", 0, 0); 
runeAnchor:SetWidth(1);
runeAnchor:SetHeight(1);

local playerAnchor = CreateFrame("Frame", nil, frame)
playerAnchor:SetPoint("CENTER", frame, "CENTER", 0, -24); 
playerAnchor:SetWidth(1);
playerAnchor:SetHeight(1);


local diseaseParent = CreateFrame("Frame", nil, diseaseAnchor)
diseaseParent:SetPoint("CENTER", diseaseAnchor, "CENTER", 0, 0); 
diseaseParent:SetWidth(32);
diseaseParent:SetHeight(16);

local targetParent = CreateFrame("Frame", nil, targetAnchor)
targetParent:SetPoint("CENTER", targetAnchor, "CENTER", 0, 0); 
targetParent:SetWidth(180);
targetParent:SetHeight(16);

local runeParent = CreateFrame("Frame", nil, runeAnchor);
runeParent:SetPoint("CENTER", runeAnchor, "CENTER", 0, 0); 
runeParent:SetWidth(120);
runeParent:SetHeight(24);

local playerParent = CreateFrame("Frame", nil, playerAnchor);
playerParent:SetPoint("CENTER", playerAnchor, "CENTER", 0, 0); 
playerParent:SetWidth(180);
playerParent:SetHeight(24);

local playerSimpleParent = CreateFrame("Frame", nil, playerAnchor);
playerSimpleParent:SetPoint("CENTER", playerAnchor, "CENTER", 0, 0); 
playerSimpleParent:SetWidth(120);
playerSimpleParent:SetHeight(12);


local targetNameAnchor = CreateFrame("Frame", nil, frame)
targetNameAnchor:SetPoint("CENTER", frame, "CENTER", 0, 20); 
targetNameAnchor:SetWidth(1);
targetNameAnchor:SetHeight(1);

local targetNameParent = CreateFrame("Frame", nil, targetNameAnchor)
targetNameParent:SetPoint("CENTER", targetNameAnchor, "CENTER", 0, 0); 
targetNameParent:SetWidth(180);
targetNameParent:SetHeight(16);

-- TargetFrame -------------------------------------
-- Backgrounds
local tarhpBack = CreateFrame("Frame", "Backgroundframe", targetParent);
tarhpBack:SetPoint("CENTER", targetParent, "CENTER", 0, 4);
tarhpBack:SetWidth(120); 
tarhpBack:SetHeight(8);
local tarhpBackTex = tarhpBack:CreateTexture("ARTWORK");
tarhpBackTex:SetAllPoints();
tarhpBackTex:SetTexture(0.4, 0, 0); 
tarhpBackTex:SetAlpha(0.4);

local tarenBack = CreateFrame("Frame", "Backgroundframe", targetParent);
tarenBack:SetPoint("CENTER", targetParent, "CENTER", 0, -4);
tarenBack:SetWidth(120); 
tarenBack:SetHeight(8);
local tarenBackTex = tarenBack:CreateTexture("ARTWORK");
tarenBackTex:SetAllPoints();
tarenBackTex:SetTexture(0.4, 0.4, 0.4); 
tarenBackTex:SetAlpha(0.4);

-- StatusBars
local targetHealthBar = CreateFrame("StatusBar", nil, tarhpBack);
targetHealthBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
targetHealthBar:GetStatusBarTexture():SetHorizTile(false);
targetHealthBar:SetMinMaxValues(0, 100);
targetHealthBar:SetWidth(120);
targetHealthBar:SetHeight(8);
targetHealthBar:SetPoint("CENTER", tarhpBack, "CENTER", 0, 0); 
targetHealthBar:SetStatusBarColor(0.6, 0, 0);

local targetEnergyBar = CreateFrame("StatusBar", nil, tarenBack);
targetEnergyBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
targetEnergyBar:GetStatusBarTexture():SetHorizTile(false);
targetEnergyBar:SetMinMaxValues(0, 100);
targetEnergyBar:SetWidth(120);
targetEnergyBar:SetHeight(8);
targetEnergyBar:SetPoint("CENTER", tarenBack, "CENTER", 0, 0); 
targetEnergyBar:SetStatusBarColor(0.6, 0.6, 0.6);

-- StatusTexts
local targetNameText = targetNameParent:CreateFontString("Target Name", "ARTWORK", "GameFontNormalSmall");
targetNameText:SetPoint("CENTER", targetNameParent, "CENTER", 0, 0);
targetNameText:SetText(0);

local targetHealthBarText = targetHealthBar:CreateFontString("Target Health Points Number", "ARTWORK", "GameFontNormalSmall");
targetHealthBarText:SetPoint("CENTER", targetHealthBar, "CENTER", 0, 1);
targetHealthBarText:SetText(0);

local targetEnergyBarText = targetEnergyBar:CreateFontString("Target Energy Number", "ARTWORK", "GameFontNormalSmall");
targetEnergyBarText:SetPoint("CENTER", targetEnergyBar, "CENTER", 0, 0);
targetEnergyBarText:SetText(0);

local tarHealthPerc = targetHealthBar:CreateFontString("Target Hit Points Percentage", "ARTWORK", "GameFontNormalSmall");
tarHealthPerc:SetPoint("CENTER", targetHealthBar, "CENTER", 74, 0);
tarHealthPerc:SetText(0);

local tarLevel = targetHealthBar:CreateFontString("Target Level", "ARTWORK", "GameFontNormalSmall");
tarLevel:SetPoint("CENTER", targetHealthBar, "CENTER", -74, 0);
tarLevel:SetText(0);

local tarEnergyPerc = targetEnergyBar:CreateFontString("Target Energy Percentage", "ARTWORK", "GameFontNormalSmall");
tarEnergyPerc:SetPoint("CENTER", targetEnergyBar, "CENTER", 74, 0);
tarEnergyPerc:SetText(0);


-- PlayerFrame -------------------------------------
-- Backgrounds
local hpBack = CreateFrame("Frame", nil, playerParent)
hpBack:SetPoint("CENTER", playerParent, "CENTER", 0, 6);
hpBack:SetWidth(120); 
hpBack:SetHeight(12);
local hpBackTex = hpBack:CreateTexture("ARTWORK");
hpBackTex:SetAllPoints();
hpBackTex:SetTexture(0, 0.4, 0); 
hpBackTex:SetAlpha(0.4);

local rpBack = CreateFrame("Frame", nil, playerParent);
rpBack:SetPoint("CENTER", playerParent, "CENTER", 0, -6);
rpBack:SetWidth(120); 
rpBack:SetHeight(12);
local rpBackTex = rpBack:CreateTexture("ARTWORK");
rpBackTex:SetAllPoints();
rpBackTex:SetTexture(0, 0.3, 0.4);
rpBackTex:SetAlpha(0.4);

local presence = CreateFrame("Frame", "Backgroundframe", hpBack)
presence:SetPoint("CENTER", hpBack, "CENTER", -72, -12);
presence:SetWidth(14); 
presence:SetHeight(14);
local presenceTex = presence:CreateTexture("ARTWORK");
presenceTex:SetAllPoints();
presenceTex:SetTexture(0, 0, 0); 
presenceTex:SetAlpha(1);

-- Statusbars
local playerHealthBar = CreateFrame("StatusBar", nil, hpBack);
playerHealthBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
playerHealthBar:GetStatusBarTexture():SetHorizTile(false);
playerHealthBar:SetMinMaxValues(0, 100);
playerHealthBar:SetWidth(120);
playerHealthBar:SetHeight(12);
playerHealthBar:SetPoint("CENTER", hpBack, "CENTER", 0, 0); 
playerHealthBar:SetStatusBarColor(0, 0.8, 0);

local runicPowerBar = CreateFrame("StatusBar", nil, rpBack);
runicPowerBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
runicPowerBar:GetStatusBarTexture():SetHorizTile(false);
runicPowerBar:SetMinMaxValues(0, 100);
runicPowerBar:SetWidth(120);
runicPowerBar:SetHeight(12);
runicPowerBar:SetPoint("CENTER", rpBack, "CENTER", 0, 0); 
runicPowerBar:SetStatusBarColor(0, 0.6, 0.7);

-- StatusTexts
local healthBarText = playerHealthBar:CreateFontString("Health Points Number", "ARTWORK", "GameFontNormalSmall");
healthBarText:SetPoint("CENTER", playerHealthBar, "CENTER", 0, 0);
healthBarText:SetText(0);

local runicPowerText = runicPowerBar:CreateFontString("Runic Power Number", "ARTWORK", "GameFontNormalSmall");
runicPowerText:SetPoint("CENTER", runicPowerBar, "CENTER", 0, 0);
runicPowerText:SetText(0);

local playerLevel = hpBack:CreateFontString("My Level", "ARTWORK", "GameFontNormalSmall");
playerLevel:SetPoint("CENTER", hpBack, "CENTER", -74, 0);
playerLevel:SetText(0);

local playerHealthPerc = hpBack:CreateFontString("Hit Points Percentage", "ARTWORK", "GameFontNormalSmall");
playerHealthPerc:SetPoint("CENTER", hpBack, "CENTER", 74, 0);
playerHealthPerc:SetText(0);


-- RuneFrame ---------------------------------------
-- Diseases
local ffTrack = CreateFrame("Frame", "Backgroundframe", diseaseParent)
ffTrack:SetPoint("CENTER", diseaseParent, "CENTER", -8, 0);
ffTrack:SetWidth(16); 
ffTrack:SetHeight(16);
local ffTrackTex = ffTrack:CreateTexture("ARTWORK");
ffTrackTex:SetAllPoints();
ffTrackTex:SetTexture("Interface\\Icons\\spell_deathknight_frostfever");
ffTrackTex:SetAlpha(1);
local ffTrackNumber = ffTrack:CreateFontString("Target Name", "ARTWORK", "GameFontNormalSmall");
ffTrackNumber:SetPoint("CENTER", ffTrack, "CENTER", -16, 0);
ffTrackNumber:SetText(0);

local bpTrack = CreateFrame("Frame", "Backgroundframe", diseaseParent)
bpTrack:SetPoint("CENTER", diseaseParent, "CENTER", 8, 0);
bpTrack:SetWidth(16); 
bpTrack:SetHeight(16);
local bpTrackTex = bpTrack:CreateTexture("ARTWORK");
bpTrackTex:SetAllPoints();
bpTrackTex:SetTexture("Interface\\Icons\\spell_deathknight_bloodplague"); 
bpTrackTex:SetAlpha(1);
local bpTrackNumber = bpTrack:CreateFontString("Target Name", "ARTWORK", "GameFontNormalSmall");
bpTrackNumber:SetPoint("CENTER", bpTrack, "CENTER", 16, 0);
bpTrackNumber:SetText(0);

ffcd = CreateFrame("Cooldown", "FFCD", ffTrack, "CooldownFrameTemplate");
ffcd:SetReverse(true);
bpcd = CreateFrame("Cooldown", "BPCD", bpTrack, "CooldownFrameTemplate");
bpcd:SetReverse(true);

-- Runes
local runeTextureName =
{
	"Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Blood",
	"Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Blood",
	"Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Frost",
	"Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Frost",
	"Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Unholy",
	"Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Unholy"
}

local runeFrame =
{
	CreateFrame("Frame", "Rune1", runeParent),
	CreateFrame("Frame", "Rune2", runeParent),
	CreateFrame("Frame", "Rune3", runeParent),
	CreateFrame("Frame", "Rune4", runeParent),
	CreateFrame("Frame", "Rune5", runeParent),
	CreateFrame("Frame", "Rune6", runeParent)
}
for i = 1,6 do
	runeFrame[i]:SetPoint("CENTER", runeParent, "CENTER", -70 + (20 * i), 0);
	runeFrame[i]:SetWidth(24);
	runeFrame[i]:SetHeight(24);
end

local runeTex =
{
	runeFrame[1]:CreateTexture("ARTWORK");
	runeFrame[2]:CreateTexture("ARTWORK");
	runeFrame[3]:CreateTexture("ARTWORK");
	runeFrame[4]:CreateTexture("ARTWORK");
	runeFrame[5]:CreateTexture("ARTWORK");
	runeFrame[6]:CreateTexture("ARTWORK");
}
for i = 1,6 do
	runeTex[i]:SetAllPoints();
	runeTex[i]:SetTexture(0, 0, 0); 
	runeTex[i]:SetAlpha(1);
end

local ringFrame =
{
	CreateFrame("Frame", "Backgroundframe", runeParent),
	CreateFrame("Frame", "Backgroundframe", runeParent),
	CreateFrame("Frame", "Backgroundframe", runeParent),
	CreateFrame("Frame", "Backgroundframe", runeParent),
	CreateFrame("Frame", "Backgroundframe", runeParent),
	CreateFrame("Frame", "Backgroundframe", runeParent)
}
for i = 1,6 do
	ringFrame[i]:SetPoint("CENTER", runeParent, "CENTER", -70 + (20 * i), 0);
	ringFrame[i]:SetWidth(24);
	ringFrame[i]:SetHeight(24);
end

local ringTex =
{
	ringFrame[1]:CreateTexture("ARTWORK");
	ringFrame[2]:CreateTexture("ARTWORK");
	ringFrame[3]:CreateTexture("ARTWORK");
	ringFrame[4]:CreateTexture("ARTWORK");
	ringFrame[5]:CreateTexture("ARTWORK");
	ringFrame[6]:CreateTexture("ARTWORK");
}
for i = 1,6 do
	ringTex[i]:SetAllPoints();
	ringTex[i]:SetTexture(0, 0, 0); 
	ringTex[i]:SetAlpha(1);
end

local runeIDs = {1, 2, 5, 6, 3, 4}
local runeAnim = {0, 0, 0, 0, 0, 0}
local runeStart = {0, 0, 0, 0, 0, 0}
local runeDuration = {0, 0, 0, 0, 0, 0}

local runeCDFrame =
{
	CreateFrame("Frame", "Backgroundframe", runeParent),
	CreateFrame("Frame", "Backgroundframe", runeParent),
	CreateFrame("Frame", "Backgroundframe", runeParent),
	CreateFrame("Frame", "Backgroundframe", runeParent),
	CreateFrame("Frame", "Backgroundframe", runeParent),
	CreateFrame("Frame", "Backgroundframe", runeParent)
}
for i = 1,6 do
	runeCDFrame[i]:SetPoint("CENTER", runeParent, "CENTER", -70 + (20 * i), 1);
	runeCDFrame[i]:SetWidth(14.7);
	runeCDFrame[i]:SetHeight(14.7);
end

local runeCooldown =
{
	CreateFrame("Cooldown", "Rune1CD", runeCDFrame[1], "CooldownFrameTemplate"),
	CreateFrame("Cooldown", "Rune2CD", runeCDFrame[2], "CooldownFrameTemplate"),
	CreateFrame("Cooldown", "Rune3CD", runeCDFrame[3], "CooldownFrameTemplate"),
	CreateFrame("Cooldown", "Rune4CD", runeCDFrame[4], "CooldownFrameTemplate"),
	CreateFrame("Cooldown", "Rune5CD", runeCDFrame[5], "CooldownFrameTemplate"),
	CreateFrame("Cooldown", "Rune6CD", runeCDFrame[6], "CooldownFrameTemplate")
}
for i = 1,6 do
	runeFrame[i]:SetFrameLevel(15);
	runeCooldown[i]:SetFrameLevel(16);
	ringFrame[i]:SetFrameLevel(17);
end

diseaseAnchor:SetFrameLevel(15);
targetAnchor:SetFrameLevel(15);
runeAnchor:SetFrameLevel(15);
playerAnchor:SetFrameLevel(15);
targetNameAnchor:SetFrameLevel(15);

if umb_show_diseases == nil then
	umb_show_diseases = 1;
end
if umb_show_target == nil then
	umb_show_target = 1;
end
if umb_show_player == nil then
	umb_show_player = 1;
end
if umb_simple_player == nil then
	umb_simple_player = 1;
end

if umb_x == nil or umb_y == nil then
	dragFrame:ClearAllPoints();
	dragFrame:SetPoint("CENTER", 0, 0);
	umb_x, umb_y = dragFrame:GetCenter();
end

if umb_scale_diseases == nil then
	umb_scale_diseases = 1;
end
if umb_scale_player == nil then
	umb_scale_player = 1;
end
if umb_scale_target == nil then
	umb_scale_target = 1;
end
if umb_scale_runes == nil then
	umb_scale_runes = 1;
end

if umb_show_combat == nil then
	umb_show_combat = 0;
elseif umb_show_combat == 1 then
	frameHideAlpha = 0;
end;

frame:SetAlpha(frameHideAlpha);

-- OnUpdate -------------------------------------
frame:SetScript("OnUpdate", function(self, elapsed)
	
	currentTime = GetTime();
	deltaTime = currentTime - newTime;
	newTime = currentTime;
	
	if umb_show_combat == 1 then
		if UnitAffectingCombat("player") == 1 or frame_locked == 1 then
			frameHideAlpha = frameHideAlpha + deltaTime * 5;
		else
			frameHideAlpha = frameHideAlpha - deltaTime;
		end
	else
		frameHideAlpha = frameHideAlpha + deltaTime;
	end
	
	if frameHideAlpha < 0 then frameHideAlpha = 0; end
	if frameHideAlpha > 1 then frameHideAlpha = 1; end
	
	frame:SetAlpha(frameHideAlpha);
	
	if frameHideAlpha == 0 then
		return;
	end
	
	for i = 1,6 do
		if GetRuneType(runeIDs[i]) == 4 then
			runeTex[i]:SetTexture("Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Death");
		else
			runeTex[i]:SetTexture(runeTextureName[i]);
		end
		
		ringTex[i]:SetTexture("Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Ring");
		
		runeStart[i], runeDuration[i] = GetRuneCooldown(runeIDs[i]);
		
		if runeStart[i] ~= 0 then
			runeCooldown[i]:SetCooldown(runeStart[i], runeDuration[i]);
			runeAnim[i] = 1;
		else
			if runeAnim[i] == 1 then
				runeAnim[i] = 0;
				runeCooldown[i]:SetCooldown(0, 0);
			end
		end
	end
	
	if umb_show_diseases == 1 then
		
		diseaseParent:Show();
		
		if UnitDebuff("target", frostFeverLocal, "", "PLAYER") then
			ffTrackTex:SetAlpha(1);
		else
			ffTrackTex:SetAlpha(0.1);
		end
		
		if UnitDebuff("target", bloodPlagueLocal, "", "PLAYER") then
			bpTrackTex:SetAlpha(1);
		else
			bpTrackTex:SetAlpha(0.1);
		end
		
		local name, _, _, _, _, dur, exp = UnitDebuff("target", frostFeverLocal, nil, "PLAYER");
		if name then
			ffTrackNumber:SetText(string.format("%d", exp - GetTime()));
		else
			ffTrackNumber:SetText(" ");
		end
		
		if name then
			ffcd:SetCooldown(exp-dur, dur, true);
		else
			ffcd:SetCooldown(0, 0);
		end
		
		local name, _, _, _, _, dur, exp = UnitDebuff("target", bloodPlagueLocal, nil, "PLAYER");
		if name then
			bpTrackNumber:SetText(string.format("%d", exp - GetTime()));
		else
			bpTrackNumber:SetText(" ");
		end
		
		if name then
			bpcd:SetCooldown(exp-dur, dur, true);
		else
			bpcd:SetCooldown(0, 0);
		end
		
	else
		diseaseParent:Hide();
	end
	
	
	if umb_show_target == 1 then
		
		targetParent:Show();
		targetNameParent:Show();
		
		targetHealthBar:SetMinMaxValues(0, UnitHealthMax("target"));
		targetHealthBar:SetValue(UnitHealth("target"));
		
		targetEnergyBar:SetMinMaxValues(0, UnitPowerMax("target"));
		targetEnergyBar:SetValue(UnitPower("target"));
		
		
		tarhp = UnitHealth("target");
		tarmax = UnitHealthMax("target");
		
		if(tarmax > 99999999) then
			targetHealthBarText:SetText(""..tarhp.."");
		else
			targetHealthBarText:SetText(""..tarhp.." / "..tarmax.."");
		end
		
		
		teamount = UnitPower("target");
		temax = UnitPowerMax("target");
		
		if(temax > 99999999) then
			targetEnergyBarText:SetText(""..teamount.."");
		else
			targetEnergyBarText:SetText(""..teamount.." / "..temax.."");
		end
		
		
		tarhpperc = UnitHealth("target")/(UnitHealthMax("target")/100);
		if UnitHealthMax("target") == 0 then
			tarHealthPerc:SetText(" ");
		else
			resulttarhp = floor( tarhpperc*10 ^ 0 + 0.5 ) / 10 ^ 0;
			tarHealthPerc:SetText(resulttarhp.."%");
		end
		
		tarenperc = UnitPower("target")/(UnitPowerMax("target")/100);
		if UnitPowerMax("target") == 0 then
			tarEnergyPerc:SetText(" ");
		else
			resulttaren = floor( tarenperc*10 ^ 0 + 0.5 ) / 10 ^ 0;
			tarEnergyPerc:SetText(resulttaren.."%");
		end
		
		targetNameText:SetText(UnitName("target"));
		
		tarlvlvalue = UnitLevel("target");
		if tarlvlvalue == -1 then
			tarLevel:SetText("Boss");
		elseif tarlvlvalue == 0 then
			tarLevel:SetText("");
		else
			tarLevel:SetText("L:"..tarlvlvalue.."");
		end
		
	else
		targetParent:Hide();
		targetNameParent:Hide();
	end
	
	
	if umb_show_player == 1 then
		if umb_simple_player == 1 then
		
			playerParent:Show();
			playerSimpleParent:Hide();
			rpBack:SetParent(playerParent);
			rpBack:SetPoint("CENTER", playerParent, "CENTER", 0, -6);
			
			playerHealthBar:SetMinMaxValues(0, UnitHealthMax("player"));
			playerHealthBar:SetValue(UnitHealth("player"));
			
			hpamount = UnitHealth("player");
			hpmax = UnitHealthMax("player");
			if(hpmax > 99999999) then
				healthBarText:SetText(""..hpamount.."");
			else
				healthBarText:SetText(""..hpamount.." / "..hpmax.."");
			end
			
			hpperc = UnitHealth("player")/(UnitHealthMax("player")/100);
			resultmyhp = floor( hpperc*10 ^ 0 + 0.5 ) / 10 ^ 0;
			playerHealthPerc:SetText(resultmyhp.."%");
			
			if UnitBuff("player", "Blood Presence", "", "PLAYER") then
				presenceTex:SetTexture("Interface\\Icons\\spell_deathknight_bloodpresence");
				presenceTex:SetAlpha(1);
			elseif UnitBuff("player", "Frost Presence", "", "PLAYER") then
				presenceTex:SetTexture("Interface\\Icons\\spell_deathknight_frostpresence"); 
				presenceTex:SetAlpha(1);
			elseif UnitBuff("player", "Unholy Presence", "", "PLAYER") then
				presenceTex:SetTexture("Interface\\Icons\\spell_deathknight_unholypresence"); 
				presenceTex:SetAlpha(1);
			else
				presenceTex:SetTexture(0, 0, 0); 
				presenceTex:SetAlpha(0);
			end
			
			playerLevel:SetText("L:"..UnitLevel("player").."");
			
		else
			
			playerParent:Hide();
			playerSimpleParent:Show();
			rpBack:SetParent(playerSimpleParent);
			rpBack:SetPoint("CENTER", playerSimpleParent, "CENTER", 0, 0);
			
		end
		
		runicPowerBar:SetMinMaxValues(0, UnitPowerMax("player",6));
		runicPowerBar:SetValue(UnitPower("player",6));
		
		rpamount = UnitPower("player",6);
		rpmax = UnitPowerMax("player",6);
		runicPowerText:SetText(""..rpamount.." / "..rpmax.."");
		
	else
		playerParent:Hide();
	end
	
	
	if frame_locked == 1 then
		if IsMouseButtonDown(1) == 1 then
			if isDragging == -1 then
				if GetMouseFocus() == targetParent or GetMouseFocus() == runeParent or GetMouseFocus() == playerParent or GetMouseFocus() == diseaseParent or GetMouseFocus() == playerSimpleParent then
					isDragging = 1;
				end
				if isDragging ~= -1 then
					xDragStart, yDragStart = GetCursorPosition();
					xDragStart = xDragStart - umb_x;
					yDragStart = yDragStart - umb_y;
				end
			else
				umb_x, umb_y = GetCursorPosition();
				umb_x = umb_x - xDragStart;
				umb_y = umb_y - yDragStart;
			end
		elseif IsMouseButtonDown(2) == 1 then
			if scaleFocus == -1 then
				if GetMouseFocus() == targetParent then
					scaleFocus = 1;
				end
				if GetMouseFocus() == runeParent then
					scaleFocus = 2;
				end
				if GetMouseFocus() == playerParent or GetMouseFocus() == playerSimpleParent then
					scaleFocus = 3;
				end
				if GetMouseFocus() == diseaseParent then
					scaleFocus = 4;
				end
				if scaleFocus ~= -1 then
					xStart, yStart = GetCursorPosition();
					prevDist = 0;
				end
			else
				xPos, yPos = GetCursorPosition();
				distance = (yStart - yPos) / 50;
				
				if scaleFocus == 1 then
					umb_scale_target = umb_scale_target - distance;
				elseif scaleFocus == 2 then
					umb_scale_runes = umb_scale_runes - distance;
				elseif scaleFocus == 3 then
					umb_scale_player = umb_scale_player - distance;
				elseif scaleFocus == 4 then
					umb_scale_diseases = umb_scale_diseases - distance;
				end
				
				if umb_scale_target < 0 then umb_scale_target = 0; end
				if umb_scale_runes < 0 then umb_scale_runes = 0; end
				if umb_scale_player < 0 then umb_scale_player = 0; end
				if umb_scale_diseases < 0 then umb_scale_diseases = 0; end
				if umb_scale_target > 5 then umb_scale_target = 5; end
				if umb_scale_runes > 5 then umb_scale_runes = 5; end
				if umb_scale_player > 5 then umb_scale_player = 5; end
				if umb_scale_diseases > 5 then umb_scale_diseases = 5; end
				
				xStart, yStart = GetCursorPosition();
			end
		end
		
		
		if IsMouseButtonDown(1) ~= 1 then
			isDragging = -1;
		end
		if IsMouseButtonDown(2) ~= 1 then
			scaleFocus = -1;
		end
	end
	
	newDiseaseScale = 1 + (umb_scale_diseases / 2) - 0.5;
	newTargetScale = 1 + (umb_scale_target / 2) - 0.5;
	newRuneScale = 1 + (umb_scale_runes / 2) - 0.5;
	newPlayerScale = 1 + (umb_scale_player / 2) - 0.5;
	
	diseaseParent:SetScale(newDiseaseScale);
	targetParent:SetScale(newTargetScale);
	runeParent:SetScale(newRuneScale);
	playerParent:SetScale(newPlayerScale);
	playerSimpleParent:SetScale(newPlayerScale);
	
	targetNameParent:SetScale(newTargetScale);
	
	if umb_show_target == 1 then
		targetPlacing = newTargetScale;
	else
		targetPlacing = 0;
	end
	
	diseaseAnchor:SetPoint("CENTER", frame, "CENTER", 0, 12 * newRuneScale + 16 * targetPlacing + 8 * newDiseaseScale);
	targetAnchor:SetPoint("CENTER", frame, "CENTER", 0, 12 * newRuneScale + 8 * newTargetScale);
	
	if umb_simple_player == 1 then
		playerAnchor:SetPoint("CENTER", frame, "CENTER", 0, -12 * newRuneScale + -12 * newPlayerScale);
	else
		playerAnchor:SetPoint("CENTER", frame, "CENTER", 0, -12 * newRuneScale + -6 * newPlayerScale); 
	end
	
	targetNameAnchor:SetPoint("CENTER", frame, "CENTER", 0, 12 * newRuneScale + 16 * newTargetScale + 16 * newDiseaseScale + 6 * newTargetScale); 
	
	newDragWidth = 120 * newRuneScale;
	newDragHeight = 24 * newRuneScale;
	newDragY = 0;
	
	if umb_show_target == 1 then
		newDragHeight = newDragHeight + 16 * newTargetScale;
		targetWidth = 120 * newTargetScale;
		if targetWidth > newDragWidth then newDragWidth = targetWidth end
		newDragY = newDragY - 8 * newTargetScale;
	end
	if umb_show_player == 1 then
		newDragHeight = newDragHeight + 24 * newPlayerScale;
		targetWidth = 120 * newPlayerScale;
		if targetWidth > newDragWidth then newDragWidth = targetWidth end
		newDragY = newDragY + 12 * newPlayerScale;
	end
	if umb_show_diseases == 1 then
		newDragHeight = newDragHeight + 16 * newDiseaseScale;
		targetWidth = 32 * newDiseaseScale;
		if targetWidth > newDragWidth then newDragWidth = targetWidth end
		newDragY = newDragY - 8 * newDiseaseScale;
	end
	
	if wasReset == 0 then
		if currentWidth ~= 0 then
			newWidth = newDragWidth - currentWidth;
			umb_x = umb_x - newWidth / 2;
		end
	end
	currentWidth = newDragWidth;
	wasReset = 0;
	
	dragFrame:SetWidth(newDragWidth);
	dragFrame:SetHeight(newDragHeight);
	frame:SetPoint("CENTER", dragFrame, "CENTER", 0, newDragY);
	
	dragFrame:ClearAllPoints();
	dragFrame:SetPoint("BOTTOMLEFT", umb_x, umb_y);
	
end)



-- Slash commands ------------------------------------
SLASH_UMBER1 = '/umber';
local function handler(msg, editbox)
local command, rest = msg:match("^(%S*)%s*(.-)$")
	if command == 'toggletarget' then
		
		if umb_show_target == 0 then
			umb_show_target = 1;
			print("|cFFFFA07AUmberRunes: |cffffffffShowing target healthbar.");
		else
			umb_show_target = 0;
			print("|cFFFFA07AUmberRunes: |cffffffffHiding target healthbar.");
		end
				
	elseif command == 'toggleplayer' then
		
		if umb_show_player == 0 then
			umb_show_player = 1;
			print("|cFFFFA07AUmberRunes: |cffffffffShowing player healthbar.");
		else
			umb_show_player = 0;
			print("|cFFFFA07AUmberRunes: |cffffffffHiding player healthbar.");
		end
				
	elseif command == 'togglediseases' then
		
		if umb_show_diseases == 0 then
			umb_show_diseases = 1;
			print("|cFFFFA07AUmberRunes: |cffffffffShowing diseases.");
		else
			umb_show_diseases = 0;
			print("|cFFFFA07AUmberRunes: |cffffffffHiding diseases.");
		end
				
	elseif command == 'reset' then
		
		dragFrame:ClearAllPoints();
		dragFrame:SetWidth(120);
		dragFrame:SetHeight(120);
		dragFrame:SetPoint("CENTER", 0, 0);
		umb_x, umb_y = floor(dragFrame:GetLeft()), floor(dragFrame:GetBottom());
		umb_scale_diseases = 1;
		umb_scale_target = 1;
		umb_scale_runes = 1;
		umb_scale_player = 1;
		wasReset = 1;
		
		print("|cFFFFA07AUmberRunes: |cffffffffFrame position and scale reset.");
		
	elseif command == 'lock' then
		
		if frame_locked == 0 then
			frame_locked = 1;
			
			diseaseParent:EnableMouse(true);
			targetParent:EnableMouse(true);
			runeParent:EnableMouse(true);
			playerParent:EnableMouse(true);
			playerSimpleParent:EnableMouse(true);
			
			print("|cFFFFA07AUmberRunes: |cffffffffFrame unlocked.");
		else
			frame_locked = 0;
			
			diseaseParent:EnableMouse(false);
			targetParent:EnableMouse(false);
			runeParent:EnableMouse(false);
			playerParent:EnableMouse(false);
			playerSimpleParent:EnableMouse(false);
			
			print("|cFFFFA07AUmberRunes: |cffffffffFrame locked.");
		end
		
	elseif command == 'setscale' then
		
		if tonumber(rest) ~= nil then
			if tonumber(rest) >= 0 and tonumber(rest) <= 5 then
				umb_scale_diseases = tonumber(rest);
				umb_scale_target = tonumber(rest);
				umb_scale_runes = tonumber(rest);
				umb_scale_player = tonumber(rest);
				print("|cFFFFA07AUmberRunes: |cffffffffScale set to "..rest..".");
			else
				print("|cFFFFA07AUmberRunes: |cffffffffUse a number between 0 and 5 to set the scale.");
			end
		else
			print("|cFFFFA07AUmberRunes: |cffffffffUse a number between 0 and 5 to set the scale.");
		end
		
	elseif command == 'toggleplayerinfo' then
		
		if umb_simple_player == 0 then
			umb_simple_player = 1;
			print("|cFFFFA07AUmberRunes: |cffffffffShowing additional player info.");
		else
			umb_simple_player = 0;
			print("|cFFFFA07AUmberRunes: |cffffffffHiding additional player info.");
		end
		
	elseif command == 'combat' then
	
		if umb_show_combat == 0 then
			umb_show_combat = 1;
			print("|cFFFFA07AUmberRunes: |cffffffffHiding when out of combat.");
		else
			umb_show_combat = 0;
			print("|cFFFFA07AUmberRunes: |cffffffffShowing when out of combat.");
		end;
		
	else
	
		print("|cFFFFA07AUmberRunes:");
		print("|cFF00FFFF/umber togglediseases |cffffffff- Toggle diseases tracking.");
		print("|cFF00FFFF/umber toggletarget |cffffffff- Toggle target bars.");
		print("|cFF00FFFF/umber toggleplayer |cffffffff- Toggle player bars.");
		print("|cFF00FFFF/umber toggleplayerinfo |cffffffff- Toggle player bars to only show a Runic Power bar or additional info.");
		print("|cFF00FFFF/umber reset |cffffffff- Reset frame position.");
		print("|cFF00FFFF/umber lock |cffffffff- Toggle addon dragging and scaling. Leftclick to drag entire frame, rightclick to scale a component.");
		print("|cFF00FFFF/umber setscale [number] |cffffffff- Set the scale of all components. (Value between 0 and 5, 1 is default)");
		print("|cFF00FFFF/umber combat |cffffffff- Toggle hiding when out of combat.");
		
	end
end
SlashCmdList["UMBER"] = handler;


-- Blizz Runes -------------------------------------
RuneButtonIndividual1:Hide();
RuneButtonIndividual2:Hide();
RuneButtonIndividual3:Hide();
RuneButtonIndividual4:Hide();
RuneButtonIndividual5:Hide();
RuneButtonIndividual6:Hide();